<?php
include '../config.php';
// prevent XSS
$_GET   = filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);
$_POST  = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);

$enviado = $_GET['enviado'];

///////////ESPAÑOL

    $time = time();

    $textoDelBoton_es = trim($_GET['textoDelBoton_es']);
    $textoDelBoton_es = urlencode($textoDelBoton_es);//WYSIWYG Editor
    $textoDelBoton_es = strip_tags($textoDelBoton_es);
    $textoDelBoton_es = htmlspecialchars($textoDelBoton_es);

    $enlace_es = trim($_POST['enlace_es']);
    $enlace_es = strip_tags($enlace_es);
    $enlace_es = htmlspecialchars($enlace_es);
    
    $layout_es = trim($_POST['layout_es']);
    $layout_es = strip_tags($layout_es);
    $layout_es = htmlspecialchars($layout_es);


    $slug_es = trim($_POST['slug_es']);
    $slug_es = strip_tags($slug_es);
    $slug_es = htmlspecialchars($slug_es);

    $texto_es = trim($_POST['texto_es64']);
    $texto_es = base64_decode($texto_es);

    $texto_es = urlencode($texto_es);//WYSIWYG Editor
    $texto_es = strip_tags($texto_es);
    $texto_es = htmlspecialchars($texto_es);

    $titulo_es = trim($_GET['titulo_es']);
    $titulo_es = urlencode($titulo_es);//WYSIWYG Editor
    $titulo_es = strip_tags($titulo_es);
    $titulo_es = htmlspecialchars($titulo_es);

    $imagen_es = '';
    $archivo_es = '';

    //////////////SUBIR ARCHIVO

    if($_FILES['archivo_es']['size'] > 0){

        if (isset($_FILES['archivo_es']) && $_FILES['archivo_es']['error'] === UPLOAD_ERR_OK)
        {
            // get details of the uploaded file
            $fileTmpPath2 = $_FILES['archivo_es']['tmp_name'];
            $fileName2 = $_FILES['archivo_es']['name'];
            $fileSize2 = $_FILES['archivo_es']['size'];
            $fileType2 = $_FILES['archivo_es']['type'];
            $fileNameCmps2 = explode(".", $fileName2);
            $fileExtension2 = strtolower(end($fileNameCmps2));
        
            // sanitize file-name
            $newFileName2 = "Privado_".$time."_es". '.' . $fileExtension2;

            // check if file has one of the following extensions
            $allowedfileExtensions2 = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'zip');
        
            if (in_array($fileExtension2, $allowedfileExtensions2))
            {
            ///////////////SUBIR A AWS
                /// AWS API keys
                $aws_access_key_id_privado = $aws_access_key_id_privado;
                $aws_secret_access_key_privado = $aws_secret_access_key_privado;
                // Bucket
                $bucket_name_privado = $bucket_name_privado;
                // AWS region and Host Name (Host names are different for each AWS region)
                // As an example these are set to us-east-1 (US Standard)
                $aws_region_privado = $aws_region_privado;
                $host_name = $bucket_name_privado . '.s3.amazonaws.com';

                // Server path where content is present. This is just an example
                //$content_path = $dest_path;
                $content2 = file_get_contents($fileTmpPath2);

                // AWS file permissions
                $content_acl = 'public-read';

                // MIME type of file. Very important to set if you later plan to load the file from a S3 url in the browser (images, for example)
                
                $content_type2 = $fileExtension;

                if($content_type2 == 'image/svg' ){ $content_type2 = "image/svg+xml";}
                if($content_type2 == 'zip' ){ $content_type2 = "application/zip";}
                if($content_type2 == 'doc' || $content_type2 == 'docx' ){ $content_type2 = "application/msword";}
                if($content_type2 == 'xls' || $content_type2 == 'xlsx' ){ $content_type2 = "application/vnd.ms-excel";}
                if($content_type2 == 'pdf' || $content_type2 == 'pdf' ){ $content_type2 = "application/pdf";}
                // Name of content on S3
                $content_title2 = 'privado/actioncards/es/'.$newFileName2;

                // Service name for S3
                $aws_service_name = 's3';

                // UTC timestamp and date
                $timestamp = gmdate('Ymd\THis\Z');
                $date = gmdate('Ymd');

                // HTTP request headers as key & value
                $request_headers = array();
                $request_headers['Content-Type'] = $content_type2;
                $request_headers['Content-Disposition'] = 'inline';
                $request_headers['Date'] = $timestamp;
                $request_headers['Host'] = $host_name;
                $request_headers['x-amz-acl'] = $content_acl;
                $request_headers['x-amz-content-sha256'] = hash('sha256', $content2);
                // Sort it in ascending order
                ksort($request_headers);

                // Canonical headers
                $canonical_headers = [];
                foreach($request_headers as $key => $value) {
                    $canonical_headers[] = strtolower($key) . ":" . $value;
                }
                $canonical_headers = implode("\n", $canonical_headers);

                // Signed headers
                $signed_headers = [];
                foreach($request_headers as $key => $value) {
                    $signed_headers[] = strtolower($key);
                }
                $signed_headers = implode(";", $signed_headers);

                // Cannonical request 
                $canonical_request = [];
                $canonical_request[] = "PUT";
                $canonical_request[] = "/" . $content_title2;
                $canonical_request[] = "";
                $canonical_request[] = $canonical_headers;
                $canonical_request[] = "";
                $canonical_request[] = $signed_headers;
                $canonical_request[] = hash('sha256', $content2);
                $canonical_request = implode("\n", $canonical_request);
                $hashed_canonical_request = hash('sha256', $canonical_request);

                // AWS Scope
                $scope = [];
                $scope[] = $date;
                $scope[] = $aws_region_privado;
                $scope[] = $aws_service_name;
                $scope[] = "aws4_request";

                // String to sign
                $string_to_sign = [];
                $string_to_sign[] = "AWS4-HMAC-SHA256"; 
                $string_to_sign[] = $timestamp; 
                $string_to_sign[] = implode('/', $scope);
                $string_to_sign[] = $hashed_canonical_request;
                $string_to_sign = implode("\n", $string_to_sign);

                // Signing key
                $kSecret = 'AWS4' . $aws_secret_access_key_privado;
                $kDate = hash_hmac('sha256', $date, $kSecret, true);
                $kRegion = hash_hmac('sha256', $aws_region_privado, $kDate, true);
                $kService = hash_hmac('sha256', $aws_service_name, $kRegion, true);
                $kSigning = hash_hmac('sha256', 'aws4_request', $kService, true);

                // Signature
                $signature = hash_hmac('sha256', $string_to_sign, $kSigning);

                // Authorization
                $authorization = [
                    'Credential=' . $aws_access_key_id_privado . '/' . implode('/', $scope),
                    'SignedHeaders=' . $signed_headers,
                    'Signature=' . $signature
                ];
                $authorization = 'AWS4-HMAC-SHA256' . ' ' . implode( ',', $authorization);

                // Curl headers
                $curl_headers = [ 'Authorization: ' . $authorization ];
                foreach($request_headers as $key => $value) {
                    $curl_headers[] = $key . ": " . $value;
                }

                $url = 'https://' . $host_name . '/' . $content_title2;
                $ch = curl_init($url);
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $curl_headers);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, false);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
                curl_setopt($ch, CURLOPT_POSTFIELDS, $content2);
                curl_exec($ch);
                $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                if($http_code != 200){
                    echo "Error AWS";
                }
                if($http_code == 200){
                    $archivo_es = $content_title2;
                }
        
                
            }
            else
            {
                $message = '<p style="color:red; font-size:12px;">Extensión de archivo no válida. Verifica que tu archivo tenga uno de los siguientes formatos: ' . implode(', ', $allowedfileExtensions).'</p>';
                echo $message;
                exit();
            }
        }
        else
        {
            $message = '<p style="color:red; font-size:12px;">Error en subida de archivo:<br></p> ';
            $message .= '<p style="color:red; font-size:12px;">Error:' . $_FILES['archivo_es']['error'].'</p>';
            echo $message;
            exit();
        }
        echo $message;
    }


    ///////////INGLÉS

    $time_en = time();
    $textoDelBoton_en = trim($_GET['textoDelBoton_en']);
    $textoDelBoton_en = urlencode($textoDelBoton_en);//WYSIWYG Editor
    $textoDelBoton_en = strip_tags($textoDelBoton_en);
    $textoDelBoton_en = htmlspecialchars($textoDelBoton_en);

    $enlace_en = trim($_POST['enlace_en']);
    $enlace_en = strip_tags($enlace_en);
    $enlace_en = htmlspecialchars($enlace_en);

    $layout_en = trim($_POST['layout_en']);
    $layout_en = strip_tags($layout_en);
    $layout_en = htmlspecialchars($layout_en);

    $slug_en = trim($_POST['slug_en']);
    $slug_en = strip_tags($slug_en);
    $slug_en = htmlspecialchars($slug_en);

    $texto_en = trim($_POST['texto_en64']);
    $texto_en = base64_decode($texto_en);
    $texto_en = urlencode($texto_en);//WYSIWYG Editor
    $texto_en = strip_tags($texto_en);
    $texto_en = htmlspecialchars($texto_en);

    $titulo_en = trim($_GET['titulo_en']);
    $titulo_en = urlencode($titulo_en);//WYSIWYG Editor
    $titulo_en = strip_tags($titulo_en);
    $titulo_en = htmlspecialchars($titulo_en);

    $imagen_en = '';
    $archivo_en = '';

   
    //////////////SUBIR ARCHIVO

    if($_FILES['archivo_en']['size'] > 0){

        if (isset($_FILES['archivo_en']) && $_FILES['archivo_en']['error'] === UPLOAD_ERR_OK)
        {
            // get details of the uploaded file
            $fileTmpPath2 = $_FILES['archivo_en']['tmp_name'];
            $fileName2 = $_FILES['archivo_en']['name'];
            $fileSize2 = $_FILES['archivo_en']['size'];
            $fileType2 = $_FILES['archivo_en']['type'];
            $fileNameCmps2 = explode(".", $fileName2);
            $fileExtension2 = strtolower(end($fileNameCmps2));
        
            // sanitize file-name
            $newFileName2 = "Privado_".$time."_en". '.' . $fileExtension2;

            // check if file has one of the following extensions
            $allowedfileExtensions2 = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'zip');
        
            if (in_array($fileExtension2, $allowedfileExtensions2))
            {
            ///////////////SUBIR A AWS
                /// AWS API keys
                $aws_access_key_id_privado = $aws_access_key_id_privado;
                $aws_secret_access_key_privado = $aws_secret_access_key_privado;
                // Bucket
                $bucket_name_privado = $bucket_name_privado;
                // AWS region and Host Name (Host names are different for each AWS region)
                // As an example these are set to us-east-1 (US Standard)
                $aws_region_privado = $aws_region_privado;
                $host_name = $bucket_name_privado . '.s3.amazonaws.com';

                // Server path where content is present. This is just an example
                //$content_path = $dest_path;
                $content2 = file_get_contents($fileTmpPath2);

                // AWS file permissions
                $content_acl = 'public-read';

                // MIME type of file. Very important to set if you later plan to load the file from a S3 url in the browser (images, for example)
                
                $content_type2 = $fileExtension;

                if($content_type2 == 'image/svg' ){ $content_type2 = "image/svg+xml";}
                if($content_type2 == 'zip' ){ $content_type2 = "application/zip";}
                if($content_type2 == 'doc' || $content_type2 == 'docx' ){ $content_type2 = "application/msword";}
                if($content_type2 == 'xls' || $content_type2 == 'xlsx' ){ $content_type2 = "application/vnd.ms-excel";}
                if($content_type2 == 'pdf' || $content_type2 == 'pdf' ){ $content_type2 = "application/pdf";}
                // Name of content on S3
                $content_title2 = 'privado/actioncards/en/'.$newFileName2;

                // Service name for S3
                $aws_service_name = 's3';

                // UTC timestamp and date
                $timestamp = gmdate('Ymd\THis\Z');
                $date = gmdate('Ymd');

                // HTTP request headers as key & value
                $request_headers = array();
                $request_headers['Content-Type'] = $content_type2;
                $request_headers['Content-Disposition'] = 'inline';
                $request_headers['Date'] = $timestamp;
                $request_headers['Host'] = $host_name;
                $request_headers['x-amz-acl'] = $content_acl;
                $request_headers['x-amz-content-sha256'] = hash('sha256', $content2);
                // Sort it in ascending order
                ksort($request_headers);

                // Canonical headers
                $canonical_headers = [];
                foreach($request_headers as $key => $value) {
                    $canonical_headers[] = strtolower($key) . ":" . $value;
                }
                $canonical_headers = implode("\n", $canonical_headers);

                // Signed headers
                $signed_headers = [];
                foreach($request_headers as $key => $value) {
                    $signed_headers[] = strtolower($key);
                }
                $signed_headers = implode(";", $signed_headers);

                // Cannonical request 
                $canonical_request = [];
                $canonical_request[] = "PUT";
                $canonical_request[] = "/" . $content_title2;
                $canonical_request[] = "";
                $canonical_request[] = $canonical_headers;
                $canonical_request[] = "";
                $canonical_request[] = $signed_headers;
                $canonical_request[] = hash('sha256', $content2);
                $canonical_request = implode("\n", $canonical_request);
                $hashed_canonical_request = hash('sha256', $canonical_request);

                // AWS Scope
                $scope = [];
                $scope[] = $date;
                $scope[] = $aws_region_privado;
                $scope[] = $aws_service_name;
                $scope[] = "aws4_request";

                // String to sign
                $string_to_sign = [];
                $string_to_sign[] = "AWS4-HMAC-SHA256"; 
                $string_to_sign[] = $timestamp; 
                $string_to_sign[] = implode('/', $scope);
                $string_to_sign[] = $hashed_canonical_request;
                $string_to_sign = implode("\n", $string_to_sign);

                // Signing key
                $kSecret = 'AWS4' . $aws_secret_access_key_privado;
                $kDate = hash_hmac('sha256', $date, $kSecret, true);
                $kRegion = hash_hmac('sha256', $aws_region_privado, $kDate, true);
                $kService = hash_hmac('sha256', $aws_service_name, $kRegion, true);
                $kSigning = hash_hmac('sha256', 'aws4_request', $kService, true);

                // Signature
                $signature = hash_hmac('sha256', $string_to_sign, $kSigning);

                // Authorization
                $authorization = [
                    'Credential=' . $aws_access_key_id_privado . '/' . implode('/', $scope),
                    'SignedHeaders=' . $signed_headers,
                    'Signature=' . $signature
                ];
                $authorization = 'AWS4-HMAC-SHA256' . ' ' . implode( ',', $authorization);

                // Curl headers
                $curl_headers = [ 'Authorization: ' . $authorization ];
                foreach($request_headers as $key => $value) {
                    $curl_headers[] = $key . ": " . $value;
                }

                $url = 'https://' . $host_name . '/' . $content_title2;
                $ch = curl_init($url);
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $curl_headers);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, false);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
                curl_setopt($ch, CURLOPT_POSTFIELDS, $content2);
                curl_exec($ch);
                $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                if($http_code != 200){
                    echo "Error AWS";
                }
                if($http_code == 200){
                    $archivo_en = $content_title2;
                }
        
                
            }
            else
            {
                $message = '<p style="color:red; font-size:12px;">Extensión de archivo no válida. Verifica que tu archivo tenga uno de los siguientes formatos: ' . implode(', ', $allowedfileExtensions).'</p>';
                echo $message;
                exit();
            }
        }
        else
        {
            $message = '<p style="color:red; font-size:12px;">Error en subida de archivo:<br></p> ';
            $message .= '<p style="color:red; font-size:12px;">Error:' . $_FILES['archivo_en']['error'].'</p>';
            echo $message;
            exit();
        }
        echo $message;
    }


    ///////////////////////PETICIÓN GRAPH CMS
    $curl = curl_init();
    curl_setopt_array($curl, array(
        CURLOPT_URL => $endpoint_graph_cms,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',

        CURLOPT_POSTFIELDS =>'{"query":"mutation MyMutation {\\r\\n  createActionCardCumplimiento(data: {archivo: \\"'.$archivo_en.'\\", textoDelBoton: \\"'.$textoDelBoton_en.'\\", enviadoRevision: \\"'.$enviado.'\\",  estatus: \\"borrador\\", layout: \\"'.$layout_en.'\\", localizations: {create: {data: {archivo: \\"'.$archivo_es.'\\", textoDelBoton: \\"'.$textoDelBoton_es.'\\",enviadoRevision: \\"'.$enviado.'\\", estatus: \\"borrador\\", layout: \\"'.$layout_es.'\\", texto: \\"'.$texto_es.'\\", enlace: \\"'.$enlace_es.'\\", privado: \\"1\\", slug: \\"'.$slug_es.'\\",  titulo: \\"'.$titulo_es.'\\"}, locale: es_MX}}, titulo: \\"'.$titulo_en.'\\", texto: \\"'.$texto_en.'\\", enlace: \\"'.$enlace_en.'\\", privado: \\"1\\", slug: \\"'.$slug_en.'\\"}) {\\r\\n    id\\r\\n  }\\r\\n}","variables":{}}',


        CURLOPT_HTTPHEADER => array(
          'Content-Type: application/json',
          'Cookie: __cfduid=da2693cdfd39b7377a8a05e305da45b8f1613001694'
        ),
      ));

    $response = curl_exec($curl);
    curl_close($curl);
    //echo $response;

    $jsonrespuesta = json_decode($response, true);
    $id = $jsonrespuesta['data']['createActionCardCumplimiento']['id'];
    //echo $id;

    if(strlen($id)>10){

        echo '
            <script>
                $("#formnew").trigger("reset");
                $("#formnew").trigger("reset");
                $("#respuestanew").append("<h5>Action Card añadido correctamente.</h5>");
            
                setTimeout(() => {
                    $(".popUpNew").fadeOut();        
                }, 3000);
            </script>';

        
    }

    else{
        $errorclass ="class='errormensaje'"; 
        echo '
        <script>
            //$("#formnew").trigger("reset");
            //$("#formnew").trigger("reset");
            $("#respuestanew").append("<p '.$errorclass.'>Ocurrió un error al añadir el contenido. Verifica la información o intenta nuevamente en unos minutos.</p>");

            setTimeout(() => {
                //$(".popUpNew").fadeOut();        
            }, 3000);
        </script>';
    }



